Element (JDOM v1.1.1)
Keywords: org.jdom.Element class

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JDOM 1.1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jdom
Class Element

    java.lang.Object
      org.jdom.Content
          org.jdom.Element

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, Parent

    public class Element

extends Content
implements Parent

An XML element. Methods allow the user to get and manipulate its child elements and content, directly access the element's textual content, manipulate its attributes, and manage namespaces.

Version:
  $Revision: 1.159 $, $Date: 2007/11/14 05:02:08 $
Author:
  Brett McLaughlin, Jason Hunter, Lucas Gonze, Kevin Regan, Dan Schaffer, Yusuf Goolamabbas, Kent C. Johnson, Jools Enticknap, Alex Rosen, Bradley S. Huffman, Victor Toni
See Also:
  Serialized Form

Field Summary
`protected java.util.List` | `additionalNamespaces` Additional namespace declarations to store on this element; useful during output
`protected java.lang.String` | `name` The local name of the element
`protected Namespace` | `namespace` The namespace of the element

Fields inherited from class org.jdom.Content
`parent`

Constructor Summary
`protected` | `Element()` This protected constructor is provided in order to support an Element subclass that wants full control over variable initialization.
`` | `Element(java.lang.String name)` Create a new element with the supplied (local) name and no namespace.
`` | `Element(java.lang.String name, Namespace namespace)` Creates a new element with the supplied (local) name and namespace.
`` | `Element(java.lang.String name, java.lang.String uri)` Creates a new element with the supplied (local) name and a namespace given by a URI.
`` | `Element(java.lang.String name, java.lang.String prefix, java.lang.String uri)` Creates a new element with the supplied (local) name and a namespace given by the supplied prefix and URI combination.

Method Summary
`Element` | `addContent(java.util.Collection newContent)` Appends all children in the given collection to the end of the content list.
`Element` | `addContent(Content child)` Appends the child to the end of the element's content list.
`Element` | `addContent(int index, java.util.Collection newContent)` Inserts the content in a collection into the content list at the given index.
`Element` | `addContent(int index, Content child)` Inserts the child into the content list at the given index.
`Element` | `addContent(java.lang.String str)` This adds text content to this element.
`void` | `addNamespaceDeclaration(Namespace additionalNamespace)` Adds a namespace declarations to this element.
`java.lang.Object` | `clone()` This returns a deep clone of this element.
`java.util.List` | `cloneContent()` Returns a list containing detached clones of this parent's content list.
`java.util.List` | `getAdditionalNamespaces()` Returns a list of the additional namespace declarations on this element.
`Attribute` | `getAttribute(java.lang.String name)` This returns the attribute for this element with the given name and within no namespace, or null if no such attribute exists.
`Attribute` | `getAttribute(java.lang.String name, Namespace ns)` This returns the attribute for this element with the given name and within the given Namespace, or null if no such attribute exists.
`java.util.List` | `getAttributes()` This returns the complete set of attributes for this element, as a `List` of `Attribute` objects in no particular order, or an empty list if there are none.
`java.lang.String` | `getAttributeValue(java.lang.String name)` This returns the attribute value for the attribute with the given name and within no namespace, null if there is no such attribute, and the empty string if the attribute value is empty.
`java.lang.String` | `getAttributeValue(java.lang.String name, Namespace ns)` This returns the attribute value for the attribute with the given name and within the given Namespace, null if there is no such attribute, and the empty string if the attribute value is empty.
`java.lang.String` | `getAttributeValue(java.lang.String name, Namespace ns, java.lang.String def)` This returns the attribute value for the attribute with the given name and within the given Namespace, or the passed-in default if there is no such attribute.
`java.lang.String` | `getAttributeValue(java.lang.String name, java.lang.String def)` This returns the attribute value for the attribute with the given name and within no namespace, or the passed-in default if there is no such attribute.
`Element` | `getChild(java.lang.String name)` This returns the first child element within this element with the given local name and belonging to no namespace.
`Element` | `getChild(java.lang.String name, Namespace ns)` This returns the first child element within this element with the given local name and belonging to the given namespace.
`java.util.List` | `getChildren()` This returns a `List` of all the child elements nested directly (one level deep) within this element, as `Element` objects.
`java.util.List` | `getChildren(java.lang.String name)` This returns a `List` of all the child elements nested directly (one level deep) within this element with the given local name and belonging to no namespace, returned as `Element` objects.
`java.util.List` | `getChildren(java.lang.String name, Namespace ns)` This returns a `List` of all the child elements nested directly (one level deep) within this element with the given local name and belonging to the given Namespace, returned as `Element` objects.
`java.lang.String` | `getChildText(java.lang.String name)` Returns the textual content of the named child element, or null if there's no such child.
`java.lang.String` | `getChildText(java.lang.String name, Namespace ns)` Returns the textual content of the named child element, or null if there's no such child.
`java.lang.String` | `getChildTextNormalize(java.lang.String name)` Returns the normalized textual content of the named child element, or null if there's no such child.
`java.lang.String` | `getChildTextNormalize(java.lang.String name, Namespace ns)` Returns the normalized textual content of the named child element, or null if there's no such child.
`java.lang.String` | `getChildTextTrim(java.lang.String name)` Returns the trimmed textual content of the named child element, or null if there's no such child.
`java.lang.String` | `getChildTextTrim(java.lang.String name, Namespace ns)` Returns the trimmed textual content of the named child element, or null if there's no such child.
`java.util.List` | `getContent()` This returns the full content of the element as a List which may contain objects of type `Text`, `Element`, `Comment`, `ProcessingInstruction`, `CDATA`, and `EntityRef`.
`java.util.List` | `getContent(Filter filter)` Return a filter view of this `Element`'s content.
`Content` | `getContent(int index)` Returns the child at the given index.
`int` | `getContentSize()` Returns the number of children in this parent's content list.
`java.util.Iterator` | `getDescendants()` Returns an iterator that walks over all descendants in document order.
`java.util.Iterator` | `getDescendants(Filter filter)` Returns an iterator that walks over all descendants in document order applying the Filter to return only elements that match the filter rule.
`java.lang.String` | `getName()` Returns the (local) name of the element (without any namespace prefix).
`Namespace` | `getNamespace()` Returns the element's `Namespace`.
`Namespace` | `getNamespace(java.lang.String prefix)` Returns the `Namespace` corresponding to the given prefix in scope for this element.
`java.lang.String` | `getNamespacePrefix()` Returns the namespace prefix of the element or an empty string if none exists.
`java.lang.String` | `getNamespaceURI()` Returns the namespace URI mapped to this element's prefix (or the in-scope default namespace URI if no prefix).
`java.lang.String` | `getQualifiedName()` Returns the full name of the element, in the form [namespacePrefix]:[localName].
`java.lang.String` | `getText()` Returns the textual content directly held under this element as a string.
`java.lang.String` | `getTextNormalize()` Returns the textual content of this element with all surrounding whitespace removed and internal whitespace normalized to a single space.
`java.lang.String` | `getTextTrim()` Returns the textual content of this element with all surrounding whitespace removed.
`java.lang.String` | `getValue()` Returns the XPath 1.0 string value of this element, which is the complete, ordered content of all text node descendants of this element (i.e. the text that's left after all references are resolved and all other markup is stripped out.)
`int` | `indexOf(Content child)` Returns the index of the supplied child in the content list, or -1 if not a child of this parent.
`boolean` | `isAncestor(Element element)` Determines if this element is the ancestor of another element.
`boolean` | `isRootElement()` Returns whether this element is a root element.
`boolean` | `removeAttribute(Attribute attribute)` This removes the supplied Attribute should it exist.
`boolean` | `removeAttribute(java.lang.String name)` This removes the attribute with the given name and within no namespace.
`boolean` | `removeAttribute(java.lang.String name, Namespace ns)` This removes the attribute with the given name and within the given Namespace.
`boolean` | `removeChild(java.lang.String name)` This removes the first child element (one level deep) with the given local name and belonging to no namespace.
`boolean` | `removeChild(java.lang.String name, Namespace ns)` This removes the first child element (one level deep) with the given local name and belonging to the given namespace.
`boolean` | `removeChildren(java.lang.String name)` This removes all child elements (one level deep) with the given local name and belonging to no namespace.
`boolean` | `removeChildren(java.lang.String name, Namespace ns)` This removes all child elements (one level deep) with the given local name and belonging to the given namespace.
`java.util.List` | `removeContent()` Removes all child content from this parent.
`boolean` | `removeContent(Content child)` Removes a single child node from the content list.
`java.util.List` | `removeContent(Filter filter)` Remove all child content from this parent matching the supplied filter.
`Content` | `removeContent(int index)` Removes and returns the child at the given index, or returns null if there's no such child.
`void` | `removeNamespaceDeclaration(Namespace additionalNamespace)` Removes an additional namespace declarations from this element.
`Element` | `setAttribute(Attribute attribute)` This sets an attribute value for this element.
`Element` | `setAttribute(java.lang.String name, java.lang.String value)` This sets an attribute value for this element.
`Element` | `setAttribute(java.lang.String name, java.lang.String value, Namespace ns)` This sets an attribute value for this element.
`Element` | `setAttributes(java.util.Collection newAttributes)` This sets the attributes of the element.
`Element` | `setAttributes(java.util.List newAttributes)` This sets the attributes of the element.
`Element` | `setContent(java.util.Collection newContent)` This sets the content of the element.
`Element` | `setContent(Content child)` Set this element's content to be the supplied child.
`Parent` | `setContent(int index, java.util.Collection newContent)` Replace the child at the given index whith the supplied collection.
`Element` | `setContent(int index, Content child)` Replace the current child the given index with the supplied child.
`Element` | `setName(java.lang.String name)` Sets the (local) name of the element.
`Element` | `setNamespace(Namespace namespace)` Sets the element's `Namespace`.
`Element` | `setText(java.lang.String text)` Sets the content of the element to be the text given.
`java.lang.String` | `toString()` This returns a `String` representation of the `Element`, suitable for debugging.

Methods inherited from class org.jdom.Content
`detach, equals, getDocument, getParent, getParentElement, hashCode, setParent`

Methods inherited from class java.lang.Object
`finalize, getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface org.jdom.Parent
`getDocument, getParent`

Field Detail

### name

    protected java.lang.String name

  The local name of the element

### namespace

    protected transient Namespace namespace

  The namespace of the element

### additionalNamespaces

    protected transient java.util.List additionalNamespaces

  Additional namespace declarations to store on this element; useful during output

Constructor Detail

### Element

    protected Element()

  This protected constructor is provided in order to support an Element subclass that wants full control over variable initialization. It intentionally leaves all instance variables null, allowing a lightweight subclass implementation. The subclass is responsible for ensuring all the get and set methods on Element behave as documented.

  When implementing an Element subclass which doesn't require full control over variable initialization, be aware that simply calling super() (or letting the compiler add the implicit super() call) will not initialize the instance variables which will cause many of the methods to throw a NullPointerException. Therefore, the constructor for these subclasses should call one of the public constructors so variable initialization is handled automatically.

### Element

    public Element(java.lang.String name,
                   Namespace namespace)

  Creates a new element with the supplied (local) name and namespace. If the provided namespace is null, the element will have no namespace.

  Parameters:
    `name` - local name of the element
    `namespace` - namespace for the element
  Throws:
    `IllegalNameException` - if the given name is illegal as an element name

### Element

    public Element(java.lang.String name)

  Create a new element with the supplied (local) name and no namespace.

  Parameters:
    `name` - local name of the element
  Throws:
    `IllegalNameException` - if the given name is illegal as an element name.

### Element

    public Element(java.lang.String name,
                   java.lang.String uri)

  Creates a new element with the supplied (local) name and a namespace given by a URI. The element will be put into the unprefixed (default) namespace.

  Parameters:
    `name` - name of the element
    `uri` - namespace URI for the element
  Throws:
    `IllegalNameException` - if the given name is illegal as an element name or the given URI is illegal as a namespace URI

### Element

    public Element(java.lang.String name,
                   java.lang.String prefix,
                   java.lang.String uri)

  Creates a new element with the supplied (local) name and a namespace given by the supplied prefix and URI combination.

  Parameters:
    `name` - local name of the element
    `prefix` - namespace prefix
    `uri` - namespace URI for the element
  Throws:
    `IllegalNameException` - if the given name is illegal as an element name, the given prefix is illegal as a namespace prefix, or the given URI is illegal as a namespace URI

Method Detail

### getName

    public java.lang.String getName()

  Returns the (local) name of the element (without any namespace prefix).

  Returns:
    local element name

### setName

    public Element setName(java.lang.String name)

  Sets the (local) name of the element.

  Parameters:
    `name` - the new (local) name of the element
  Returns:
    the target element
  Throws:
    `IllegalNameException` - if the given name is illegal as an Element name

### getNamespace

    public Namespace getNamespace()

  Returns the element's `Namespace`.

  Returns:
    the element's namespace

### setNamespace

    public Element setNamespace(Namespace namespace)

  Sets the element's `Namespace`. If the provided namespace is null, the element will have no namespace.

  Parameters:
    `namespace` - the new namespace
  Returns:
    the target element

### getNamespacePrefix

    public java.lang.String getNamespacePrefix()

  Returns the namespace prefix of the element or an empty string if none exists.

  Returns:
    the namespace prefix

### getNamespaceURI

    public java.lang.String getNamespaceURI()

  Returns the namespace URI mapped to this element's prefix (or the in-scope default namespace URI if no prefix). If no mapping is found, an empty string is returned.

  Returns:
    the namespace URI for this element

### getNamespace

    public Namespace getNamespace(java.lang.String prefix)

  Returns the `Namespace` corresponding to the given prefix in scope for this element. This involves searching up the tree, so the results depend on the current location of the element. Returns null if there is no namespace in scope with the given prefix at this point in the document.

  Parameters:
    `prefix` - namespace prefix to look up
  Returns:
    the Namespace for this prefix at this location, or null if none

### getQualifiedName

    public java.lang.String getQualifiedName()

  Returns the full name of the element, in the form [namespacePrefix]:[localName]. If the element does not have a namespace prefix, then the local name is returned.

  Returns:
    qualified name of the element (including namespace prefix)

### addNamespaceDeclaration

    public void addNamespaceDeclaration(Namespace additionalNamespace)

  Adds a namespace declarations to this element. This should not be used to add the declaration for this element itself; that should be assigned in the construction of the element. Instead, this is for adding namespace declarations on the element not relating directly to itself. It's used during output to for stylistic reasons move namespace declarations higher in the tree than they would have to be.

  Parameters:
    `additionalNamespace` - namespace to add
  Throws:
    `IllegalAddException` - if the namespace prefix collides with another namespace prefix on the element

### removeNamespaceDeclaration

    public void removeNamespaceDeclaration(Namespace additionalNamespace)

  Removes an additional namespace declarations from this element. This should not be used to remove the declaration for this element itself; that should be handled in the construction of the element. Instead, this is for removing namespace declarations on the element not relating directly to itself. If the declaration is not present, this method does nothing.

  Parameters:
    `additionalNamespace` - namespace to remove

### getAdditionalNamespaces

    public java.util.List getAdditionalNamespaces()

  Returns a list of the additional namespace declarations on this element. This includes only additional namespace, not the namespace of the element itself, which can be obtained through `getNamespace()`. If there are no additional declarations, this returns an empty list. Note, the returned list is unmodifiable.

  Returns:
    a List of the additional namespace declarations

### getValue

    public java.lang.String getValue()

  Returns the XPath 1.0 string value of this element, which is the complete, ordered content of all text node descendants of this element (i.e. the text that's left after all references are resolved and all other markup is stripped out.)

  Specified by:
    `getValue` in class `Content`
  Returns:
    a concatentation of all text node descendants

### isRootElement

    public boolean isRootElement()

  Returns whether this element is a root element. This can be used in tandem with `Content.getParent()` to determine if an element has any "attachments" to a parent element or document.

  Returns:
    whether this is a root element

### getContentSize

    public int getContentSize()

  Description copied from interface: `Parent`
  Returns the number of children in this parent's content list. Children may be any `Content` type.

  Specified by:
    `getContentSize` in interface `Parent`
  Returns:
    number of children

### indexOf

    public int indexOf(Content child)

  Description copied from interface: `Parent`
  Returns the index of the supplied child in the content list, or -1 if not a child of this parent.

  Specified by:
    `indexOf` in interface `Parent`
  Parameters:
    `child` - child to search for
  Returns:
    index of child, or -1 if not found

### getText

    public java.lang.String getText()

  Returns the textual content directly held under this element as a string. This includes all text within this single element, including whitespace and CDATA sections if they exist. It's essentially the concatenation of all `Text` and `CDATA` nodes returned by `getContent()`. The call does not recurse into child elements. If no textual value exists for the element, an empty string is returned.

  Returns:
    text content for this element, or empty string if none

### getTextTrim

    public java.lang.String getTextTrim()

  Returns the textual content of this element with all surrounding whitespace removed. If no textual value exists for the element, or if only whitespace exists, the empty string is returned.

  Returns:
    trimmed text content for this element, or empty string if none

### getTextNormalize

    public java.lang.String getTextNormalize()

  Returns the textual content of this element with all surrounding whitespace removed and internal whitespace normalized to a single space. If no textual value exists for the element, or if only whitespace exists, the empty string is returned.

  Returns:
    normalized text content for this element, or empty string if none

### getChildText

    public java.lang.String getChildText(java.lang.String name)

  Returns the textual content of the named child element, or null if there's no such child. This method is a convenience because calling `getChild().getText()` can throw a NullPointerException.

  Parameters:
    `name` - the name of the child
  Returns:
    text content for the named child, or null if no such child

### getChildTextTrim

    public java.lang.String getChildTextTrim(java.lang.String name)

  Returns the trimmed textual content of the named child element, or null if there's no such child. See ``getTextTrim()`` for details of text trimming.

  Parameters:
    `name` - the name of the child
  Returns:
    trimmed text content for the named child, or null if no such child

### getChildTextNormalize

    public java.lang.String getChildTextNormalize(java.lang.String name)

  Returns the normalized textual content of the named child element, or null if there's no such child. See ``getTextNormalize()`` for details of text normalizing.

  Parameters:
    `name` - the name of the child
  Returns:
    normalized text content for the named child, or null if no such child

### getChildText

    public java.lang.String getChildText(java.lang.String name,
                                         Namespace ns)

  Returns the textual content of the named child element, or null if there's no such child.

  Parameters:
    `name` - the name of the child
    `ns` - the namespace of the child
  Returns:
    text content for the named child, or null if no such child

### getChildTextTrim

    public java.lang.String getChildTextTrim(java.lang.String name,
                                             Namespace ns)

  Returns the trimmed textual content of the named child element, or null if there's no such child.

  Parameters:
    `name` - the name of the child
    `ns` - the namespace of the child
  Returns:
    trimmed text content for the named child, or null if no such child

### getChildTextNormalize

    public java.lang.String getChildTextNormalize(java.lang.String name,
                                                  Namespace ns)

  Returns the normalized textual content of the named child element, or null if there's no such child.

  Parameters:
    `name` - the name of the child
    `ns` - the namespace of the child
  Returns:
    normalized text content for the named child, or null if no such child

### setText

    public Element setText(java.lang.String text)

  Sets the content of the element to be the text given. All existing text content and non-text context is removed. If this element should have both textual content and nested elements, use ``setContent(java.util.Collection)`` instead. Setting a null text value is equivalent to setting an empty string value.

  Parameters:
    `text` - new text content for the element
  Returns:
    the target element
  Throws:
    `IllegalDataException` - if the assigned text contains an illegal character such as a vertical tab (as determined by `Verifier.checkCharacterData(java.lang.String)`)

### getContent

    public java.util.List getContent()

  This returns the full content of the element as a List which may contain objects of type `Text`, `Element`, `Comment`, `ProcessingInstruction`, `CDATA`, and `EntityRef`. The List returned is "live" in document order and modifications to it affect the element's actual contents. Whitespace content is returned in its entirety.

  Sequential traversal through the List is best done with an Iterator since the underlying implement of List.size() may require walking the entire list.

  Specified by:
    `getContent` in interface `Parent`
  Returns:
    a `List` containing the mixed content of the element: may contain `Text`, ``Element``, ``Comment``, ``ProcessingInstruction``, ``CDATA``, and ``EntityRef`` objects.

### getContent

    public java.util.List getContent(Filter filter)

  Return a filter view of this `Element`'s content.

  Sequential traversal through the List is best done with a Iterator since the underlying implement of List.size() may require walking the entire list.

  Specified by:
    `getContent` in interface `Parent`
  Parameters:
    `filter` - `Filter` to apply
  Returns:
    `List` - filtered Element content

### removeContent

    public java.util.List removeContent()

  Removes all child content from this parent.

  Specified by:
    `removeContent` in interface `Parent`
  Returns:
    list of the old children detached from this parent

### removeContent

    public java.util.List removeContent(Filter filter)

  Remove all child content from this parent matching the supplied filter.

  Specified by:
    `removeContent` in interface `Parent`
  Parameters:
    `filter` - filter to select which content to remove
  Returns:
    list of the old children detached from this parent

### setContent

    public Element setContent(java.util.Collection newContent)

  This sets the content of the element. The supplied List should contain only objects of type `Element`, `Text`, `CDATA`, `Comment`, `ProcessingInstruction`, and `EntityRef`.

  When all objects in the supplied List are legal and before the new content is added, all objects in the old content will have their parentage set to null (no parent) and the old content list will be cleared. This has the effect that any active list (previously obtained with a call to `getContent()` or `getChildren()`) will also change to reflect the new content. In addition, all objects in the supplied List will have their parentage set to this element, but the List itself will not be "live" and further removals and additions will have no effect on this elements content. If the user wants to continue working with a "live" list, then a call to setContent should be followed by a call to `getContent()` or `getChildren()` to obtain a "live" version of the content.

  Passing a null or empty List clears the existing content.

  In event of an exception the original content will be unchanged and the objects in the supplied content will be unaltered.

  Parameters:
    `newContent` - `Collection` of content to set
  Returns:
    this element modified
  Throws:
    `IllegalAddException` - if the List contains objects of illegal types or with existing parentage.

### setContent

    public Element setContent(int index,
                              Content child)

  Replace the current child the given index with the supplied child.

  In event of an exception the original content will be unchanged and the supplied child will be unaltered.

  Parameters:
    `index` - - index of child to replace.
    `child` - - child to add.
  Returns:
    element on which this method was invoked
  Throws:
    `IllegalAddException` - if the supplied child is already attached or not legal content for this parent.
    `java.lang.IndexOutOfBoundsException` - if index is negative or greater than the current number of children.

### setContent

    public Parent setContent(int index,
                             java.util.Collection newContent)

  Replace the child at the given index whith the supplied collection.

  In event of an exception the original content will be unchanged and the content in the supplied collection will be unaltered.

  Parameters:
    `index` - - index of child to replace.
    `newContent` - - `Collection` of content to replace child.
  Returns:
    object on which this method was invoked
  Throws:
    `IllegalAddException` - if the collection contains objects of illegal types.
    `java.lang.IndexOutOfBoundsException` - if index is negative or greater than the current number of children.

### addContent

    public Element addContent(java.lang.String str)

  This adds text content to this element. It does not replace the existing content as does `setText()`.

  Parameters:
    `str` - `String` to add
  Returns:
    this element modified
  Throws:
    `IllegalDataException` - if `str` contains an illegal character such as a vertical tab (as determined by `Verifier.checkCharacterData(java.lang.String)`)

### addContent

    public Element addContent(Content child)

  Appends the child to the end of the element's content list.

  Parameters:
    `child` - child to append to end of content list
  Returns:
    the element on which the method was called
  Throws:
    `IllegalAddException` - if the given child already has a parent.

### addContent

    public Element addContent(java.util.Collection newContent)

  Appends all children in the given collection to the end of the content list. In event of an exception during add the original content will be unchanged and the objects in the supplied collection will be unaltered.

  Parameters:
    `newContent` - `Collection` of content to append
  Returns:
    the element on which the method was called
  Throws:
    `IllegalAddException` - if any item in the collection already has a parent or is of an inappropriate type.

### addContent

    public Element addContent(int index,
                              Content child)

  Inserts the child into the content list at the given index.

  Parameters:
    `index` - location for adding the collection
    `child` - child to insert
  Returns:
    the parent on which the method was called
  Throws:
    `java.lang.IndexOutOfBoundsException` - if index is negative or beyond the current number of children
    `IllegalAddException` - if the given child already has a parent.

### addContent

    public Element addContent(int index,
                              java.util.Collection newContent)

  Inserts the content in a collection into the content list at the given index. In event of an exception the original content will be unchanged and the objects in the supplied collection will be unaltered.

  Parameters:
    `index` - location for adding the collection
    `newContent` - `Collection` of content to insert
  Returns:
    the parent on which the method was called
  Throws:
    `java.lang.IndexOutOfBoundsException` - if index is negative or beyond the current number of children
    `IllegalAddException` - if any item in the collection already has a parent or is of an inappropriate type.

### cloneContent

    public java.util.List cloneContent()

  Description copied from interface: `Parent`
  Returns a list containing detached clones of this parent's content list.

  Specified by:
    `cloneContent` in interface `Parent`
  Returns:
    list of cloned child content

### getContent

    public Content getContent(int index)

  Description copied from interface: `Parent`
  Returns the child at the given index.

  Specified by:
    `getContent` in interface `Parent`
  Parameters:
    `index` - location of desired child
  Returns:
    child at the given index

### removeContent

    public boolean removeContent(Content child)

  Description copied from interface: `Parent`
  Removes a single child node from the content list.

  Specified by:
    `removeContent` in interface `Parent`
  Parameters:
    `child` - child to remove
  Returns:
    whether the removal occurred

### removeContent

    public Content removeContent(int index)

  Description copied from interface: `Parent`
  Removes and returns the child at the given index, or returns null if there's no such child.

  Specified by:
    `removeContent` in interface `Parent`
  Parameters:
    `index` - index of child to remove
  Returns:
    detached child at given index or null if no

### setContent

    public Element setContent(Content child)

  Set this element's content to be the supplied child.

  If the supplied child is legal content for this parent and before it is added, all content in the current content list will be cleared and all current children will have their parentage set to null.

  This has the effect that any active list (previously obtained with a call to one of the `getContent()` methods will also change to reflect the new content. In addition, all content in the supplied collection will have their parentage set to this parent. If the user wants to continue working with a "live" list of this parent's child, then a call to setContent should be followed by a call to one of the `getContent()` methods to obtain a "live" version of the children.

  Passing a null child clears the existing content.

  In event of an exception the original content will be unchanged and the supplied child will be unaltered.

  Parameters:
    `child` - new content to replace existing content
  Returns:
    the parent on which the method was called
  Throws:
    `IllegalAddException` - if the supplied child is already attached or not legal content for an Element

### isAncestor

    public boolean isAncestor(Element element)

  Determines if this element is the ancestor of another element.

  Parameters:
    `element` - `Element` to check against
  Returns:
    `true` if this element is the ancestor of the supplied element

### getAttributes

    public java.util.List getAttributes()

  This returns the complete set of attributes for this element, as a `List` of `Attribute` objects in no particular order, or an empty list if there are none. The returned list is "live" and changes to it affect the element's actual attributes.

  Returns:
    attributes for the element

### getAttribute

    public Attribute getAttribute(java.lang.String name)

  This returns the attribute for this element with the given name and within no namespace, or null if no such attribute exists.

  Parameters:
    `name` - name of the attribute to return
  Returns:
    attribute for the element

### getAttribute

    public Attribute getAttribute(java.lang.String name,
                                  Namespace ns)

  This returns the attribute for this element with the given name and within the given Namespace, or null if no such attribute exists.

  Parameters:
    `name` - name of the attribute to return
    `ns` - `Namespace` to search within
  Returns:
    attribute for the element

### getAttributeValue

    public java.lang.String getAttributeValue(java.lang.String name)

  This returns the attribute value for the attribute with the given name and within no namespace, null if there is no such attribute, and the empty string if the attribute value is empty.

  Parameters:
    `name` - name of the attribute whose value to be returned
  Returns:
    the named attribute's value, or null if no such attribute

### getAttributeValue

    public java.lang.String getAttributeValue(java.lang.String name,
                                              java.lang.String def)

  This returns the attribute value for the attribute with the given name and within no namespace, or the passed-in default if there is no such attribute.

  Parameters:
    `name` - name of the attribute whose value to be returned
    `def` - a default value to return if the attribute does not exist
  Returns:
    the named attribute's value, or the default if no such attribute

### getAttributeValue

    public java.lang.String getAttributeValue(java.lang.String name,
                                              Namespace ns)

  This returns the attribute value for the attribute with the given name and within the given Namespace, null if there is no such attribute, and the empty string if the attribute value is empty.

  Parameters:
    `name` - name of the attribute whose valud is to be returned
    `ns` - `Namespace` to search within
  Returns:
    the named attribute's value, or null if no such attribute

### getAttributeValue

    public java.lang.String getAttributeValue(java.lang.String name,
                                              Namespace ns,
                                              java.lang.String def)

  This returns the attribute value for the attribute with the given name and within the given Namespace, or the passed-in default if there is no such attribute.

  Parameters:
    `name` - name of the attribute whose valud is to be returned
    `ns` - `Namespace` to search within
    `def` - a default value to return if the attribute does not exist
  Returns:
    the named attribute's value, or the default if no such attribute

### setAttributes

    public Element setAttributes(java.util.Collection newAttributes)

  This sets the attributes of the element. The supplied Collection should contain only objects of type `Attribute`.

  When all objects in the supplied List are legal and before the new attributes are added, all old attributes will have their parentage set to null (no parent) and the old attribute list will be cleared. This has the effect that any active attribute list (previously obtained with a call to `getAttributes()`) will also change to reflect the new attributes. In addition, all attributes in the supplied List will have their parentage set to this element, but the List itself will not be "live" and further removals and additions will have no effect on this elements attributes. If the user wants to continue working with a "live" attribute list, then a call to setAttributes should be followed by a call to `getAttributes()` to obtain a "live" version of the attributes.

  Passing a null or empty List clears the existing attributes.

  In cases where the List contains duplicate attributes, only the last one will be retained. This has the same effect as calling `setAttribute(Attribute)` sequentially.

  In event of an exception the original attributes will be unchanged and the attributes in the supplied attributes will be unaltered.

  Parameters:
    `newAttributes` - `Collection` of attributes to set
  Returns:
    this element modified
  Throws:
    `IllegalAddException` - if the List contains objects that are not instances of `Attribute`, or if any of the `Attribute` objects have conflicting namespace prefixes.

### setAttributes

    public Element setAttributes(java.util.List newAttributes)

  This sets the attributes of the element. It's an alternate form of the method, accepting a `List` instead of a `Collection`, for backward compatibility.

### setAttribute

    public Element setAttribute(java.lang.String name,
                                java.lang.String value)

  This sets an attribute value for this element. Any existing attribute with the same name and namespace URI is removed.

  Parameters:
    `name` - name of the attribute to set
    `value` - value of the attribute to set
  Returns:
    this element modified
  Throws:
    `IllegalNameException` - if the given name is illegal as an attribute name.
    `IllegalDataException` - if the given attribute value is illegal character data (as determined by `Verifier.checkCharacterData(java.lang.String)`).

### setAttribute

    public Element setAttribute(java.lang.String name,
                                java.lang.String value,
                                Namespace ns)

  This sets an attribute value for this element. Any existing attribute with the same name and namespace URI is removed.

  Parameters:
    `name` - name of the attribute to set
    `value` - value of the attribute to set
    `ns` - namespace of the attribute to set
  Returns:
    this element modified
  Throws:
    `IllegalNameException` - if the given name is illegal as an attribute name, or if the namespace is an unprefixed default namespace
    `IllegalDataException` - if the given attribute value is illegal character data (as determined by `Verifier.checkCharacterData(java.lang.String)`).
    `IllegalAddException` - if the attribute namespace prefix collides with another namespace prefix on the element.

### setAttribute

    public Element setAttribute(Attribute attribute)

  This sets an attribute value for this element. Any existing attribute with the same name and namespace URI is removed.

  Parameters:
    `attribute` - `Attribute` to set
  Returns:
    this element modified
  Throws:
    `IllegalAddException` - if the attribute being added already has a parent or if the attribute namespace prefix collides with another namespace prefix on the element.

### removeAttribute

    public boolean removeAttribute(java.lang.String name)

  This removes the attribute with the given name and within no namespace. If no such attribute exists, this method does nothing.

  Parameters:
    `name` - name of attribute to remove
  Returns:
    whether the attribute was removed

### removeAttribute

    public boolean removeAttribute(java.lang.String name,
                                   Namespace ns)

  This removes the attribute with the given name and within the given Namespace. If no such attribute exists, this method does nothing.

  Parameters:
    `name` - name of attribute to remove
    `ns` - namespace URI of attribute to remove
  Returns:
    whether the attribute was removed

### removeAttribute

    public boolean removeAttribute(Attribute attribute)

  This removes the supplied Attribute should it exist.

  Parameters:
    `attribute` - Reference to the attribute to be removed.
  Returns:
    whether the attribute was removed

### toString

    public java.lang.String toString()

  This returns a `String` representation of the `Element`, suitable for debugging. If the XML representation of the `Element` is desired, `XMLOutputter.outputString(Element)` should be used.

  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    `String` - information about the `Element`

### clone

    public java.lang.Object clone()

  This returns a deep clone of this element. The new element is detached from its parent, and getParent() on the clone will return null.

  Specified by:
    `clone` in interface `Parent`
  Overrides:
    `clone` in class `Content`
  Returns:
    the clone of this element

### getDescendants

    public java.util.Iterator getDescendants()

  Returns an iterator that walks over all descendants in document order.

  Specified by:
    `getDescendants` in interface `Parent`
  Returns:
    an iterator to walk descendants

### getDescendants

    public java.util.Iterator getDescendants(Filter filter)

  Returns an iterator that walks over all descendants in document order applying the Filter to return only elements that match the filter rule. With filters you can match only Elements, only Comments, Elements or Comments, only Elements with a given name and/or prefix, and so on.

  Specified by:
    `getDescendants` in interface `Parent`
  Parameters:
    `filter` - filter to select which descendants to see
  Returns:
    an iterator to walk descendants within a filter

### getChildren

    public java.util.List getChildren()

  This returns a `List` of all the child elements nested directly (one level deep) within this element, as `Element` objects. If this target element has no nested elements, an empty List is returned. The returned list is "live" in document order and changes to it affect the element's actual contents.

  Sequential traversal through the List is best done with a Iterator since the underlying implement of List.size() may not be the most efficient.

  No recursion is performed, so elements nested two levels deep would have to be obtained with:

         Iterator itr = (currentElement.getChildren()).iterator();
         while(itr.hasNext()) {
           Element oneLevelDeep = (Element)itr.next();
           List twoLevelsDeep = oneLevelDeep.getChildren();
           // Do something with these children
         }

  Returns:
    list of child `Element` objects for this element

### getChildren

    public java.util.List getChildren(java.lang.String name)

  This returns a `List` of all the child elements nested directly (one level deep) within this element with the given local name and belonging to no namespace, returned as `Element` objects. If this target element has no nested elements with the given name outside a namespace, an empty List is returned. The returned list is "live" in document order and changes to it affect the element's actual contents.

  Please see the notes for ``getChildren()`` for a code example.

  Parameters:
    `name` - local name for the children to match
  Returns:
    all matching child elements

### getChildren

    public java.util.List getChildren(java.lang.String name,
                                      Namespace ns)

  This returns a `List` of all the child elements nested directly (one level deep) within this element with the given local name and belonging to the given Namespace, returned as `Element` objects. If this target element has no nested elements with the given name in the given Namespace, an empty List is returned. The returned list is "live" in document order and changes to it affect the element's actual contents.

  Please see the notes for ``getChildren()`` for a code example.

  Parameters:
    `name` - local name for the children to match
    `ns` - `Namespace` to search within
  Returns:
    all matching child elements

### getChild

    public Element getChild(java.lang.String name,
                            Namespace ns)

  This returns the first child element within this element with the given local name and belonging to the given namespace. If no elements exist for the specified name and namespace, null is returned.

  Parameters:
    `name` - local name of child element to match
    `ns` - `Namespace` to search within
  Returns:
    the first matching child element, or null if not found

### getChild

    public Element getChild(java.lang.String name)

  This returns the first child element within this element with the given local name and belonging to no namespace. If no elements exist for the specified name and namespace, null is returned.

  Parameters:
    `name` - local name of child element to match
  Returns:
    the first matching child element, or null if not found

### removeChild

    public boolean removeChild(java.lang.String name)

  This removes the first child element (one level deep) with the given local name and belonging to no namespace. Returns true if a child was removed.

  Parameters:
    `name` - the name of child elements to remove
  Returns:
    whether deletion occurred

### removeChild

    public boolean removeChild(java.lang.String name,
                               Namespace ns)

  This removes the first child element (one level deep) with the given local name and belonging to the given namespace. Returns true if a child was removed.

  Parameters:
    `name` - the name of child element to remove
    `ns` - `Namespace` to search within
  Returns:
    whether deletion occurred

### removeChildren

    public boolean removeChildren(java.lang.String name)

  This removes all child elements (one level deep) with the given local name and belonging to no namespace. Returns true if any were removed.

  Parameters:
    `name` - the name of child elements to remove
  Returns:
    whether deletion occurred

### removeChildren

    public boolean removeChildren(java.lang.String name,
                                  Namespace ns)

  This removes all child elements (one level deep) with the given local name and belonging to the given namespace. Returns true if any were removed.

  Parameters:
    `name` - the name of child elements to remove
    `ns` - `Namespace` to search within
  Returns:
    whether deletion occurred

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JDOM 1.1.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2007 Jason Hunter, Brett McLaughlin. All Rights Reserved.